import Combine
import SwiftUIArchitectureCore

public protocol {{ module_info.name }}ParentService {
	typealias {{ module_info.name }}Publisher = AnyPublisher<{{ module_info.name }}State.OutwardAction, Never>
	typealias {{ module_info.name }}Dispatcher = AnyReportDispatcher<ModuleStore<{{ module_info.name }}State>>
	
	func bind(publisher: {{ module_info.name }}Publisher, dispatcher: {{ module_info.name }}Dispatcher) -> [AnyCancellable]
}

enum {{ module_info.name }}Module {
	static func initialize(
		parentService: {{ module_info.name }}ParentService
	) -> (ModuleStore<{{ module_info.name }}State>, {{ module_info.name }}Graph) {
		let store = ModuleStore<{{ module_info.name }}State>()
		let subscriptions = parentService.bind(
			publisher: store.publisher,
			dispatcher: store.eraseToAnyReportDispatcher()
		)
		let graph = {{ module_info.name }}Graph(subscriptions: subscriptions)
		return (store, graph)
	}
}
